package RSSReader::Gtk2UI::Category::InfoPane;
use strict;
use RSSReader::Category;
use Data::Dumper;
use base qw(RSSReader::Logger);

our $_cats_pane;

sub new {
	my $c = shift;
	my %a = @_;

	if (exists $_cats_pane->{$a{id}}) { return $_cats_pane->{$a{id}}; }
		
	#otherwise .. fetch the cat and build the widget... after this
	# only redraws are needed.

	my $cat = RSSReader::Category->new(id=>$a{id});
	my $s = bless { _cat => $cat, id => $a{id} }, $c;

	$_cats_pane->{$a{id}}=$s;
	#TODO Register em updates da categoria, redraw proposals

	$s->{_widget} = new Gtk2::Table( 3,3,0 );
	$s->{_max_width} = 100;
	$s->{_max_heigth} = 30;
	$s->_redraw();
	

	return $s;
}

sub show {
	my $s = shift;
	$s->widget()->show()
}

sub widget {
	my $s = shift;
	return $s->{_widget};
}

sub id {
	my $s = shift;
	return $s->{id};
}

sub _redraw {
	my $s = shift;

	my $name_label = Gtk2::Label->new();
	$name_label->set_markup( '<b>New item aggregation for '.$s->{_cat}->label().".</b>\n All new items in this category and its sub categories." );
	$name_label->set_justify('center');
	$s->{_widget}->attach( $name_label, 0, 1, 0, 1, ['fill', 'expand'],['fill','expand']		 , 0 ,5 );


	$s->{_widget}->show_all();
}

1;
