package RSSReader::Gtk2UI::Feed::MessageList;
use strict;
use RSSReader::Feed;
use RSSReader::Feed::Message;
use base qw( RSSReader::Notifier RSSReader::Logger RSSReader::Gtk2UI::MessageList );
use Data::Dumper;

our $_msg_lists;

sub new {
        my $c = shift;
        my %a = @_;
        if (exists $_msg_lists->{$a{id}}) { return $_msg_lists->{$a{id}}; }
	
	my $s = $c->SUPER::new(%a);

        #otherwise .. fetch the feed and build the widget... after this
        my $col_name = $s->{_list_view}->get_column(1);
	$col_name->set_visible(0);

        my $feed = RSSReader::Feed->new(id=>$a{id});
        $s->{_feed} = $feed;
	$s->{id}    = $a{id};
	$feed->notify_me( event=>'new_message', caller=>$s, call=>'_new_message');

	$_msg_lists->{$a{id}} = $s;
	$s->_populate();
	return $s;
}

sub _populate {
    my $s = shift;
    foreach my $msg (@{$s->{_feed}->messages}){
	$s->add_msg($msg);	
    }
}

sub show {
	my $s = shift;
	my %a = @_;

	$s->SUPER::show(%a);

	my $k = 1;
	while (my $col = $s->{_list_view}->get_column($k) ) {
		my $size;
		if ( $s->{_prefs}->per_view_columns() ) {
			$size = $s->{_prefs}->get('feed_view_'.$s->{_feed}->id(),"column_".$col->{_position}."_width");	
		} else {
			$size = $s->{_prefs}->get('feed_view_global', "column_".$col->{_position}."_width");
		}
		$k++;
		$size = 50 unless $size;
		$s->log_spam("set col ".$col->{_position}." size $size");
		$col->set_fixed_width($size);
	}
}

sub hide {
	my $s = shift;
	my $k = 1;
        while (my $col = $s->{_list_view}->get_column($k) ) {
		$s->log_spam("saving col ".$col->{_position}." with size : ".$col->get_width);
		my $size = $col->get_width || 1;
		$s->{_prefs}->set('feed_view_'.$s->{_feed}->id(),"column_".$col->{_position}."_width",$size );
		unless ( $s->{_prefs}->per_view_columns() ) {
			$s->{_prefs}->set('feed_view_global', "column_".$col->{_position}."_width",$size );
		}
		$k++;
        }
}
1;
