package RSSReader::Gtk2UI::Launcher;
use base qw(RSSReader::Logger);
use RSSReader::Gtk2UI::Preferences;
use Data::Dumper;

our $_lauchers_registred;

sub register {
	my $c = shift;
	my %a = @_;

	return unless ($a{id} && $a{package});
	$_launchers_registred->{$a{id}} = $a{package};
	$c->log_debug("Got a launcher register : $a{id} ($a{package})");
	$a{package}->new();
}

sub get_launcher  {
	my $c = shift;
	my $id = shift;

	$c->log_debug("Notifier $id was requested (".$_launchers_registred->{$id}.")");
	if (exists($_launchers_registred->{$id}) && defined($_launchers_registred->{$id}) ) {
		my $_not;
		eval {
		  $_not = ($_launchers_registred->{$id})->new()
		};
		if ($@) {
		  __PACKAGE__->log_warn("Could not load laucher $id: $@");
		  return undef;
		}
		return $_not;

	}
	$c->log_debug("Notifier does not exist");
	return undef
}

sub get_launchers {
	my @to_ret;

	foreach ( keys %$_launchers_registred ) {
		push @to_ret, __PACKAGE__->get_launcher($_);
	}
	return wantarray ? @to_ret : \@to_ret;
}

sub get_option {
  	my $s      = shift;
	my $option = shift;

	my $val = RSSReader::Gtk2UI::Preferences->new->get_module_option(type=>'launchers', id=>$s->id, option=>$option);
	if ((!defined($val)) && ($option eq 'enabled')) { return 0 }

	return $val
}

sub set_option {
	my $s 	   = shift;
	my $option = shift;
	my $val    = shift;

	RSSReader::Gtk2UI::Preferences->new->set_module_option(type=>'launchers', id=>$s->id, option=>$option, value=>$val);
	return 1;
}

#Auto discover
my $myname = __PACKAGE__;
my $me = $myname;
$me =~ s/\:\:/\//g;

foreach my $d (@INC) {
   chomp $d;
   if (-d "$d/$me/") {
     local(*F_DIR);
     opendir(*F_DIR, "$d/$me/");
     while ( my $b = readdir(*F_DIR)) {
         next unless $b =~ /^(.*)\.pm$/;
         __PACKAGE__->log_error("Found launcher $1"); 
	 my $package_name = __PACKAGE__."::$1";
	 eval "require $package_name";
	 if ($@) { 
		__PACKAGE__->log_error("Error loading launcher: $1 : $@");
	 }
     }
   }
}

1;
