package RSSReader::Gtk2UI::Search::MessageList;
use strict;
use RSSReader;
use RSSReader::Feed::Message;
use RSSReader::Notifier;
use Data::Dumper;

use base qw(RSSReader::Notifier RSSReader::Logger RSSReader::Gtk2UI::MessageList);

sub new {
	my $c = shift;
	my %a = @_;
	my $s = $c->SUPER::new(%a);

	$s->_populate(messages=>$a{messages});

    	return $s;
}

sub clear { }

sub _populate {
    my $s = shift;
    my %a = @_;
    foreach my $msg (@{$a{messages}}){
	$s->add_msg($msg);	
    }
}


sub show {
        my $s = shift;
	my %a = @_;
                                                                                
        $s->SUPER::show(%a);

        my $k = 1;
        while (my $col = $s->{_list_view}->get_column($k) ) {
                my $size;
                if ( $s->{_prefs}->per_view_columns() ) {
                        $size = $s->{_prefs}->get('search_view',"column_".$col->{_position}."_width");
                } else {
                        $size = $s->{_prefs}->get('category_view_global', "column_".$col->{_position}."_width");
                }
                $k++;
                $size = 50 unless $size;
                $s->log_spam("set col ".$col->{_position}." size $size");
                $col->set_fixed_width($size);
        }
}
                                                                                                                                                                            
sub hide {
        my $s = shift;
        my $k = 1;
        while (my $col = $s->{_list_view}->get_column($k) ) {
                $s->log_spam("saving col ".$col->{_position}." with size : ".$col->get_width);
                my $size = $col->get_width || 1;
                $s->{_prefs}->set('search_view',"column_".$col->{_position}."_width",$size );
                unless ( $s->{_prefs}->per_view_columns() ) {
                        $s->{_prefs}->set('category_view_global', "column_".$col->{_position}."_width",$size );
                }
                $k++;
        }
	
	foreach my $msg (@{$s->listed_messages()} ) {
    	 $msg->forget_notify_me(event=>'keep_toggled',   call=>'_message_changed', caller=>$s);
    	 $msg->forget_notify_me(event=>'mark_read',      call=>'_message_changed', caller=>$s);
    	 $msg->forget_notify_me(event=>'mark_unread',    call=>'_message_changed', caller=>$s);
    	 $msg->forget_notify_me(event=>'message_deleted',call=>'_delete_message',  caller=>$s);
	}
	$s->{_prefs}->forget_notify_me(event=>"show_category_col_changed", caller=>$s, call=>'_setup_category_column');
	
}

sub DESTROY {
	print STDERR "Search messagel destroyed\n";
}

1;
